package Msm::AdminInit;
use strict;
use Msm::MySql;

sub new{
	my $self=shift;
	my $config=shift;
	my $hash={};
	bless $hash,$self;
	$hash->{Config}=$config;
	$hash->{SuExec}=0;
	return $hash;
}

sub getCData{
	my $self=shift;
	my $name=shift;
	return $self->{Config}->getConfigData('',$name);
}


sub execute{
	my $self=shift;
	my $cgi=shift;
	my $html='';

	if($cgi->param('mode') eq 'run'){
		$self->setConfig($cgi->param('suexec'),$cgi->param('indexurl'),
		$cgi->param('indexdir'),$cgi->param('user'),$cgi->param('pass'));
		if($cgi->param('db') eq 'mysql'){
			$self->createTable(
			$cgi->param('dbhost'),
			$cgi->param('dbname'),
			$cgi->param('dbuser'),
			$cgi->param('dbpass')
			);
		}else{
			$self->{Config}->setConfigDataOverWrite('default','savename',$self->{Config}->getConfigInfo('default','savename'),'File');
		}

		$self->createDir();
		$self->setPermission();
		$html=$self->getInitOKHtml();

		$self->{Config}->setConfigDataOverWrite('default','init',$self->{Config}->getConfigInfo('default','init'),'1');
		my $sc=$ENV{SCRIPT_NAME};
		$sc=~s/^(.*)\/.*$/$1/;
		$self->{Config}->setConfigDataOverWrite('default','script',$self->{Config}->getConfigInfo('default','script'),$sc.'/ms.cgi');
		$self->{Config}->setConfigDataOverWrite('default','adminscript',$self->{Config}->getConfigInfo('default','adminscript'),$ENV{SCRIPT_NAME});
		$self->{Config}->setConfigDataOverWrite('default','anascript',$self->{Config}->getConfigInfo('default','anascript'),$sc.'/ana.cgi');

		#RtBOB
		$self->{Config}->rewriteConfig($self->{Config}->getAllConfigDataMap(),$self->{Config}->getConfigData('','fileperm'));
	}else{
		$html=$self->getInitHtml();
	}
	return $html;
}

sub createTable{
	my $self=shift;
	my $dbhost=shift;
	my $dbname=shift;
	my $dbuser=shift;
	my $dbpass=shift;


	$self->{Config}->setConfigDataOverWrite('default','dbhost',$self->{Config}->getConfigInfo('default','dbhost'),$dbhost);
	$self->{Config}->setConfigDataOverWrite('default','dbname',$self->{Config}->getConfigInfo('default','dbname'),$dbname);
	$self->{Config}->setConfigDataOverWrite('default','dbuser',$self->{Config}->getConfigInfo('default','dbuser'),$dbuser);
	$self->{Config}->setConfigDataOverWrite('default','dbpass',$self->{Config}->getConfigInfo('default','dbpass'),$dbpass);

	my $db=new Msm::MySql($self->{Config});
	$db->connect;
	unless($db){
		die 'db error';
	}
	eval{$db->execute('drop table sketch_dir');};
	$db->execute("
create table sketch_dir(
	blogid		varchar(128),
	dir			varchar(255),
	date		int,
	primary key (blogid,dir),
	index(blogid)
)
");

	eval{$db->execute('drop table plug_dir');};
	$db->execute("
create table plug_dir(
	blogid		varchar(128),
	plug		varchar(128),
	dir			varchar(255),
	primary key (blogid,plug,dir),
	index(blogid)
)
");

	eval{$db->execute('drop table plug');};
	$db->execute("
create table plug(
	blogid		varchar(128),
	plug		varchar(128),
	dir			varchar(255),
	file		varchar(255),
	data		text,
	primary key (blogid,plug,dir,file),
	index(blogid)
)");

	eval{$db->execute('drop table sketch');};
	$db->execute("
create table sketch(
	blogid		varchar(128),
	dir			varchar(255),
	file		varchar(255),
	title		varchar(255),
	comment		text,
	date		int,
	primary key (blogid,dir,file),
	index(blogid,dir),
	index(blogid,date),
	index(blogid)
)");

	eval{$db->execute('drop table user');};
	$db->execute("
create table user(
	id		varchar(128) not null,
	name_1 varchar(128) not null,
	name_2 varchar(128) not null,
	info varchar(512) not null,
	data varchar(512) not null,
	primary key(id,name_1,name_2),
	index(id)
)");

	eval{$db->execute('drop table blog');};
	$db->execute("
create table blog(
	id		varchar(128) not null,
	name_1 varchar(128) not null,
	name_2 varchar(128) not null,
	info varchar(512) not null,
	data varchar(512) not null,
	primary key(id,name_1,name_2),
	index(id)
)");

	eval{$db->execute('drop table bloguser');};
	$db->execute("
create table bloguser(
	id		varchar(128) not null,
	name_1 varchar(128) not null,
	name_2 varchar(128) not null,
	info varchar(512) not null,
	data varchar(512) not null,
	primary key(id,name_1,name_2),
	index(id)
)");

	eval{$db->execute('drop table userblog');};
	$db->execute("
create table userblog(
	id		varchar(128) not null,
	name_1 varchar(128) not null,
	name_2 varchar(128) not null,
	info varchar(512) not null,
	data varchar(512) not null,
	primary key(id,name_1,name_2),
	index(id)
)");

	eval{$db->execute('drop table username');};
	$db->execute("
create table username(
	id		varchar(128) not null,
	name_1 varchar(128) not null,
	name_2 varchar(128) not null,
	info varchar(512) not null,
	data varchar(512) not null,
	primary key(id,name_1,name_2),
	index(id)
)");

	$db->disconnect;

	$self->{Config}->setConfigDataOverWrite('default','savename',$self->{Config}->getConfigInfo('default','savename'),'MySql');
}

sub setConfig{
	my $hash=shift;
	my $suexec=shift;
	my $indexurl=shift;
	my $indexdir=shift;
	my $user=shift;
	my $pass=shift;
	$hash->{SuExec}=$suexec;

	if($suexec eq '1'){
		$hash->{Config}->setConfigDataOverWrite('default','dirperm',$hash->{Config}->getConfigInfo('default','dirperm'),'0755');
		$hash->{Config}->setConfigDataOverWrite('default','fileperm',$hash->{Config}->getConfigInfo('default','fileperm'),'0644');
	}else{
		$hash->{Config}->setConfigDataOverWrite('default','dirperm',$hash->{Config}->getConfigInfo('default','dirperm'),'0777');
		$hash->{Config}->setConfigDataOverWrite('default','fileperm',$hash->{Config}->getConfigInfo('default','fileperm'),'0666');
	}

	$hash->{Config}->setConfigDataOverWrite('default','staticindexurl',$hash->{Config}->getConfigInfo('default','staticindexurl'),$indexurl);
	$hash->{Config}->setConfigDataOverWrite('default','staticindexdir',$hash->{Config}->getConfigInfo('default','staticindexdir'),$indexdir);
	$hash->{Config}->setConfigDataOverWrite('default','adminuser',$hash->{Config}->getConfigInfo('default','adminuser'),$user);
	$hash->{Config}->setConfigDataOverWrite('default','adminpass',$hash->{Config}->getConfigInfo('default','adminpass'),$pass);

}

sub createDir{
	my $self=shift;
	my $io=new Msm::IO($self->{Config}->getConfigData('','fileperm'),$self->{Config}->getConfigData('','dirperm'));

	$io->createDir($self->getCData('staticindexdir').'dummy');
	$io->createDir($self->getCData('userdatadir').'/dummy');
}

sub setPermission{
	my $self=shift;
	my $io=new Msm::IO($self->{Config});

	#fBNg
	if($self->{SuExec} eq '1'){
		chmod 0755,'./';
		chmod 0755,'./Msm';
		chmod 0700,'./plug';
		chmod 0700,'./ini';
	}else{
		chmod 0777,'./';
		chmod 0755,'./Msm';
		chmod 0755,'./plug';
		chmod 0777,'./ini';
	}
	chmod oct($self->getCData('dirperm')),$self->getCData('staticindexdir');
	chmod oct($self->getCData('dirperm')),$self->getCData('userdatadir');


	#t@CƂ
	chmod oct($self->getCData('fileperm')),'./ini/AdminConfig.cgi';

}


sub getfiles{
	my $self=shift;
	my $dir=shift;
	my $list=shift;
	my @dir=();
	opendir DIR,$dir;
	while(my $entry=readdir DIR){

		if($entry =~ /^\./){
			next;
		}
		if(-f "$dir/$entry"){
			push @{$list},"$dir/$entry";
			next;
		}

		push @dir,$dir.'/'.$entry;
	}
	closedir(DIR);
	foreach(@dir){
		$list=$self->getfiles($_,$list);
	}
	return $list;
}

sub _setDirPerm{
	my $self=shift;
	my $dir=shift;

	opendir DIR,$dir;
	while(my $entry=readdir DIR){
		if(-f $dir."/$entry"){
			chmod oct($self->getCData('fileperm')),$dir."/$entry";
		}
	}
	closedir(DIR);
}

sub getInitHtml{
	my $self=shift;

	my $html='';

	my $sc=$ENV{SCRIPT_NAME};
	$sc=~s/(.*\/).*/$1/;
$html=<<HTML;
<html>
<body>
<h1>MySketch</h1>
<p>MySketch̏s܂B</p>
<form action="$ENV{SCRIPT_NAME}" method="post">
<h2>ݒ</h2>
<h3>Ǘ҃[U[(p)</h3>
<input type="text" name="user" value="" size=""><br>
<h3>Ǘ҃pX[h(p)</h3>
<input type="text" name="pass" value="" size=""><br>
<h3>MySketchݒupXݒ</h3>
<p>
MySkethݒuꏊ̃pXݒ肵܂B<br>
http://www.xxxx.xx/MySketch/uO/<br>
ƂɃuOݒu\\\Ȃ<br>
http://www.xxxx.xx/̃hCƃuOpXĂB<br>
/MySketch/<br>
ƏĂB<br>
T[ocgi̓fBNghtmlcgiȂΕύXȂقǂł傤B
</p>
<input type="text" name="indexurl" value="$sc" size="60"><br>
<h3>LURL̈ʒums.cgi猩[J̑΃pX܂͐΃pXĂB(/ŏI悤)</h3>
<p><br>
オ/MySketch/
<br>
ms.cgihttp://www.xxxx.xx/MySketch/ms.cgiɂƂꍇ<br>
΃pX<br>
./<br>
Ɠ͂ĂB<br>
΃pX<br>
/usr/local/apache/htdocs/MySketch/<br>
ƂɂȂł傤BiT[o[ɂ肱ƂȂ܂Bj<br>
Ȃ̃T[ocgi̓fBNghtmlcss삷ȂΕύX͂ȂɂȂقǂł傤B<br>
</p>
<input type="text" name="indexdir" value="./" size="60" ><br>
<h3>T[oSuExecgpĂ邩H</h3>
<p>
T[oWindowsȂ΂̐ݒ͂ǂł\\\܂BCGI701ȂǂŎgpĂꍇ
SuExecgpĂ\\\\̂ŎgpĂIĂBԈႦꍇMySketch͓삵܂̂
ȂꍇMySketch̃t@Cׂč폜ĂxĂB
</p>
<input type="radio" name="suexec" value="0">gpĂȂ
<br>
<input type="radio" name="suexec" value="1" checked="checked">gpĂ
<br>
<h3>DB̑I</h3>
<p>gpf[^x[XIĂB
<br>
MySQL킩Ȃꍇ̓t@Cw肵ĂB
</p>
<input type="radio" name="db" value="file" checked="checked">t@C
<br>
<input type="radio" name="db" value="mysql">MySQL
<br>
<h3>DB̐ݒ</h3>
<p>L̐ݒMySQLÎ݂̐ݒĂB
</p>
DBzXg <br><input type="text" name="dbhost" value="localhost" size=""><br>
ڑf[^x[X <br><input type="text" name="dbname" value="" size=""><br>
[U[<br><input type="text" name="dbuser" value="" size=""><br>
pX[h <br><input type="text" name="dbpass" value="" size=""><br>
<p>
<input type="submit" value="s">
</p>
<input type="hidden" name="mode" value="run">
</form>
</body>
</html>
HTML

	return $html;
}

sub getInitOKHtml{
	my $self=shift;

	my $html='';
$html=<<HTML;
<html>
<body>
<h1>MySketch</h1>
<p>MySketch̏܂I</p>
<a href="$ENV{SCRIPT_NAME}">Top</a>
</body>
</html>
HTML

	return $html;
}

1;
