package Msm::Backup;

use strict;
sub new{
	my $self=shift;
	my $ms=shift;
	my $hash={};
	bless $hash,$self;
	$hash->{MS}=$ms;
	use Msm::Backup::File;
	eval('use Msm::Backup::'.$ms->getAdConfig->getConfigData('','savename').';');
	eval('$hash->{DBCLASS}=new Msm::Backup::'.$ms->getAdConfig->getConfigData('','savename').'($hash);');

	return $hash;
}


sub getMS{
	my $self=shift;
	return $self->{MS};
}

sub getDataXML{
	my $self=shift;
	my $start_time=shift;
	my $end_time=shift;
	my $xml='';
	my $MShash=$self->getMS();
	my $datadir=$MShash->getDataDir();

	my %file=%{$MShash->getSketchFiles('','','','')};

$xml=<<XML;
<?xml version="1.0" encoding="Shift_JIS" ?>
<data>
XML

	foreach my $v(sort {$file{$b} <=> $file{$a}} keys %file){
		my $time=$file{$v};
		if($time < $start_time || $time > $end_time){next;}
		my $data=$MShash->getSketchData($v);
		my $come='';
		$v=~s/^$datadir(.*)$/$1/;
		$come=$data->{comment};
		$v=$MShash->getCGI->escapeHTML($v);
		$come=$MShash->getCGI->escapeHTML($come);
		my $title=$MShash->getCGI->escapeHTML($data->{title});
		chomp $title;
$xml.=<<XML;
	<filedata>
		<name>$v</name>
		<timestamp>$time</timestamp>
		<title>$title</title>
		<value>$come</value>
	</filedata>
XML
	}

$xml.=<<XML;
</data>
XML
	return $xml;
}

sub setTimestamp{
	my $self=shift;
	return $self->{DBCLASS}->setTimestamp();
}

sub recoveryData{
	my $self=shift;
	my $xml=shift;
	my $option=shift;
	return $self->{DBCLASS}->recoveryData($xml,$option);
}

sub recoveryPlugData{
	my $self=shift;
	my $xml=shift;
	my $option=shift;
	return $self->{DBCLASS}->recoveryPlugData($xml,$option);
}


sub getPlugDataXML{
	my $self=shift;
	my $start_time=shift;
	my $end_time=shift;
	my $xml='';
	my $MShash=$self->getMS();
	my $datadir=$MShash->getPlugDataDir();

	my $hash={};
	my $dirs=$MShash->getPlugDirs($MShash->getPlugDataDir(),{});
	foreach(keys %{$dirs}){
		$hash=$MShash->getPlugDirFiles($_,$hash);
	}
	my %file=%{$hash};
$xml=<<XML;
<?xml version="1.0" encoding="Shift_JIS" ?>
<data>
XML

	foreach my $v(sort {$file{$b} <=> $file{$a}} keys %file){
		$v=~s/^$datadir//;
		my $plug=$v;
		my $dir='';
		my $file='';
		if($v=~/^\/(.+?)(\/.+)\/(.+)$/){
			$plug=$1;
			$dir=$2;
			$file=$3;
		}elsif($v=~/^\/(.*?)\/(.+)$/){
			$plug=$1;
			$file=$2;
		}
		if($plug eq 'EazyAnalyzer'){next;}
		(my $time=$file)=~s/\.txt//i;
		if($time > 0 && ($time < $start_time || $time > $end_time)){next;}
		my @ret=$MShash->readPlugData($plug,$dir,$file);
		my $come='';

		$come.=$_ foreach(@ret);
		$come=$MShash->getCGI->escapeHTML($come);

$xml.=<<XML;
	<filedata>
		<plug>$plug</plug>
		<name>$dir/$file</name>
		<value>$come</value>
	</filedata>
XML

	}

$xml.=<<XML;
</data>
XML
	return $xml;
}

1;
