package Msm::Config::MySql;

use strict;

sub new{
	my $self=shift;
	my $config=shift;
	my $dbclass=shift;
	my $hash={};
	bless $hash,$self;
	$hash->{Config}=$config;
	$hash->{DBCLASS}=$dbclass;
	return $hash;
}

sub readConfig(){
	my $self=shift;

	my $db=$self->{Config}->getDB();

	my $table='';
	my $id='';
	if($self->{Config}->{FILENAME} =~ /^(.+?)\_(.+?)$/){
		$table=$1;
		$id=$2
	}
	#print $self->{Config}->{FILENAME};
	my @line=();
	@line=$db->execute('SELECT * FROM $table WHERE id=?',($id));
	unless(@line){
		$self->{Config}->{NEW}=1;
	}


	foreach my $href(@line){
			my $plug=$href->{name_1};
			my $name=$href->{name_2};
			my $info=$href->{info};
			my $data=$href->{data};
			#Array
			if($data =~ /\((.*)\)/){
				my @data=();
				push @data,$1 while($data =~ /'(.*?)'/go);
				$data=\@data;
			}
			if($name eq 'staticindexurl'){
				$data=~s/^http:\/\/.*?(\/.*)$/$1/;
			}

			$self->{Config}->setConfigData($plug,$name,$info,$data);
	}
}

sub rewriteConfig(){

	my $self=shift;
	my $hash=shift;
	my $fileperm=shift;

	my $table='';
	my $id='';
	if($self->{Config}->{FILENAME} =~ /^(.+?)\_(.+?)$/){
		$table=$1;
		$id=$2
	}

	my $db=$self->{Config}->getDB();

	$db->execute("delete from $table where id=?",($id));

	my $out='';
	foreach my $v(@{$self->{Config}->{LIST}}){
		my($plug,$name)=split(/\./,$v);
		my $sth;
		if(ref($hash->{$plug}->{$name}->{value}) eq 'ARRAY'){
			my $value='(';
			foreach(@{$hash->{$plug}->{$name}->{value}}){
				$value.=q{'}.$_.q{',};
			}
			$value=~s/,$//;
			$value.=')';


			$db->execute("insert into $table values(?,?,?,?,?)",
			($id,$plug,$name,$hash->{$plug}->{$name}->{info},$value)
			);

		}else{
			$db->execute("insert into $table values(?,?,?,?,?)",
			($id,$plug,$name,$hash->{$plug}->{$name}->{info},$hash->{$plug}->{$name}->{value})
			);

		}
	}

	$self->{Config}->_readConfig();
}

1;
