package Msm::Init;
use strict;

sub new{
	my $self=shift;
	my $config=shift;
	my $hash={};
	bless $hash,$self;
	$hash->{Config}=$config;
	$hash->{SuExec}=0;
	return $hash;
}

sub getCData{
	my $self=shift;
	my $name=shift;
	return $self->{Config}->getConfigData('',$name);
}

sub execute{
	my $self=shift;
	my $cgi=shift;
	my $html='';

	if($cgi->param('mode') eq 'run'){
		$self->setConfig($cgi->param('suexec'),$cgi->param('indexurl'),
		$cgi->param('indexdir'),$cgi->param('user'),$cgi->param('pass'),
		$cgi->param('title'));
		$self->createDir();
		$self->setPermission();
		$html=$self->getInitOKHtml();

		$self->{Config}->setConfigDataOverWrite('default','init',$self->{Config}->getConfigInfo('default','init'),'1');
		my $sc=$ENV{SCRIPT_NAME};
		$sc=~s/^(.*)\/.*$/$1/;
		$self->{Config}->setConfigDataOverWrite('default','script',$self->{Config}->getConfigInfo('default','script'),$ENV{SCRIPT_NAME});
		$self->{Config}->setConfigDataOverWrite('EazyAnalyzer','anascript',$self->{Config}->getConfigInfo('EazyAnalyzer','anascript'),$sc.'/ana.cgi');

		#RtBOB
		$self->{Config}->rewriteConfig($self->{Config}->getAllConfigDataMap(),$self->{Config}->getConfigData('','fileperm'));
	}else{
		$html=$self->getInitHtml();
	}
	return $html;
}


sub setConfig{
	my $hash=shift;
	my $suexec=shift;
	my $indexurl=shift;
	my $indexdir=shift;
	my $user=shift;
	my $pass=shift;
	my $title=shift;
	$hash->{SuExec}=$suexec;

	if($suexec eq '1'){
		$hash->{Config}->setConfigDataOverWrite('default','dirperm',$hash->{Config}->getConfigInfo('default','dirperm'),'0755');
		$hash->{Config}->setConfigDataOverWrite('default','fileperm',$hash->{Config}->getConfigInfo('default','fileperm'),'0644');
	}else{
		$hash->{Config}->setConfigDataOverWrite('default','dirperm',$hash->{Config}->getConfigInfo('default','dirperm'),'0777');
		$hash->{Config}->setConfigDataOverWrite('default','fileperm',$hash->{Config}->getConfigInfo('default','fileperm'),'0666');
	}

	$hash->{Config}->setConfigDataOverWrite('default','staticindexurl',$hash->{Config}->getConfigInfo('default','staticindexurl'),$indexurl);
	$hash->{Config}->setConfigDataOverWrite('default','staticindexdir',$hash->{Config}->getConfigInfo('default','staticindexdir'),$indexdir);
	$hash->{Config}->setConfigDataOverWrite('default','adminuser',$hash->{Config}->getConfigInfo('default','adminuser'),$user);
	$hash->{Config}->setConfigDataOverWrite('default','adminpass',$hash->{Config}->getConfigInfo('default','adminpass'),$pass);
	$hash->{Config}->setConfigDataOverWrite('default','msname',$hash->{Config}->getConfigInfo('default','msname'),$title);
}

sub createDir{
	my $self=shift;
	my $io=new Msm::IO($self->{Config}->getConfigData('','fileperm'),$self->{Config}->getConfigData('','dirperm'));

	$io->createDir($self->getCData('staticindexdir').'dummy');
	$io->createDir($self->getCData('staticindexdir').'category/dummy');
	$io->createDir($self->getCData('staticindexdir').'date/dummy');
	$io->createDir($self->getCData('datadir').'/dummy');
	$io->createDir($self->getCData('staticindexdir').'files/dummy');
	$io->createDir($self->getCData('plugdatadir').'/dummy');
	$io->createDir($self->getCData('tempdir').'/dummy');
	$io->createDir($self->getCData('staticindexdir').'css/dummy');
}

sub setPermission{
	my $self=shift;
	my $io=new Msm::IO($self->{Config}->getConfigData('','fileperm'),$self->{Config}->getConfigData('','dirperm'));

	#fBNg
	if($self->{SuExec} eq '1'){
		chmod 0755,'./';
		chmod 0755,'./Msm';
		chmod 0700,'./plug';
		chmod 0700,'./ini';
	}else{
		chmod 0777,'./';
		chmod 0755,'./Msm';
		chmod 0755,'./plug';
		chmod 0777,'./ini';
	}
	chmod oct($self->getCData('dirperm')),$self->getCData('staticindexdir');
	chmod oct($self->getCData('dirperm')),$self->getCData('staticindexdir').'category';
	chmod oct($self->getCData('dirperm')),$self->getCData('staticindexdir').'date';
	chmod oct($self->getCData('dirperm')),$self->getCData('datadir');
	chmod oct($self->getCData('dirperm')),$self->getCData('staticindexdir').'files';
	chmod oct($self->getCData('dirperm')),$self->getCData('plugdatadir');
	chmod oct($self->getCData('dirperm')),$self->getCData('tempdir');
	chmod oct($self->getCData('dirperm')),$self->getCData('staticindexdir').'css';

	#t@CRs[
	$self->copy();

	#t@CƂ
	chmod oct($self->getCData('fileperm')),'./Config.cgi';
	$self->_setDirPerm($self->getCData('staticindexdir').'css');
	$self->_setDirPerm($self->getCData('tempdir'));

}

sub copy{
	my $self=shift;
	my $io=new Msm::IO($self->{Config}->getConfigData('','fileperm'),$self->{Config}->getConfigData('','dirperm'));

	my $dir='./inittmp/css';
	opendir DIR,$dir;
	while(my $entry=readdir DIR){
		if(-f $dir.'/'.$entry){
			my $ret=$io->readFile($dir.'/'.$entry);
			#u
			$ret=~s/\[%\s*Config\.default\.(.+?)\s*%\]/$self->getCData($1)/ego;
			$io->writeFile($self->getCData('staticindexdir').'css/'.$entry,$ret);
		}
	}
	closedir(DIR);

	$dir='./inittmp/template';
	my @files=@{$self->getfiles($dir,[])};
	foreach my $v(@files){
		my $v_tmp=$v;
		$v_tmp=~s/^$dir//;
		$io->createDir($self->getCData('tempdir').$v_tmp);
		my $ret=$io->readFile($v);
		$io->writeFile($self->getCData('tempdir').$v_tmp,$ret);
	}

	$dir='./inittmp/files';
	@files=@{$self->getfiles($dir,[])};
	foreach my $v(@files){
		my $v_tmp=$v;
		$v_tmp=~s/^$dir//;
		my $ret=$io->readFile($v,1);
		$io->writeFile($self->getCData('staticindexdir').'files'.$v_tmp,$ret,1);
	}
}

sub getfiles{
	my $self=shift;
	my $dir=shift;
	my $list=shift;
	my @dir=();
	opendir DIR,$dir;
	while(my $entry=readdir DIR){

		if($entry =~ /^\./){
			next;
		}
		if(-f $dir.'/'.$entry){
			push @{$list},$dir.'/'.$entry;
			next;
		}

		push @dir,$dir.'/'.$entry;
	}
	closedir(DIR);
	foreach(@dir){
		$list=$self->getfiles($_,$list);
	}
	return $list;
}

sub _setDirPerm{
	my $self=shift;
	my $dir=shift;

	opendir DIR,$dir;
	while(my $entry=readdir DIR){
		if(-f $dir.'/'.$entry){
			chmod oct($self->getCData('fileperm')),$dir.'/'.$entry;
		}
	}
	closedir(DIR);
}

sub getInitHtml{
	my $self=shift;

	my $html='';

	my $sc=$ENV{SCRIPT_NAME};
	$sc=~s/(.*\/).*/$1/;
$html=<<HTML;
<html>
<body>
<h1>MySketch</h1>
<p>MySketch̏s܂B</p>
<form action="$ENV{SCRIPT_NAME}" method="post">
<h2>ݒ</h2>
<h3>uO^Cg</h3>
<input type="text" name="title" value="" size=""><br/>
<h3>[U[</h3>
<input type="text" name="user" value="" size=""><br/>
<h3>pX[h</h3>
<input type="text" name="pass" value="" size=""><br/>
<h3>index.html쐬pX(/ŏI悤)</h3>
<p><br>
http://localhost/xxx/blog/ɍ쐬Ȃ<br>
/xxx/blog/Ɠ͂ĉB<br>
Ȃ̃T[ocgi̓fBNghtmlcss삷ȂΕύX͂ȂɂȂقǂł傤B
</p>
<input type="text" name="indexurl" value="$sc" size="60"><br/>
<h3>LURL̈ʒums.cgi猩΃pX(/ŏI悤)</h3>
<p><br>
オ/xxx/blog/
<br>
ms.cgihttp://localhost/xxx/cgi-bin/ms.cgiɂƂ<br>
../blog/Ɠ͂ĉB<br>
Ȃ̃T[ocgi̓fBNghtmlcss삷ȂΕύX͂ȂɂȂقǂł傤B
</p>
<input type="text" name="indexdir" value="./" size="60" ><br/>
<h3>T[oSuExecgpĂ邩H</h3>
<p>
T[oWindowsȂ΂̐ݒ͂ǂł\\\܂BCGI701ȂǂŎgpĂꍇ
SuExecgpĂ\\\\̂ŎgpĂIĂBԈႦꍇMySketch͓삵܂̂
ȂꍇMySketch̃t@Cׂč폜ĂxĂB
</p>
<input type="radio" name="suexec" value="0">gpĂȂ
<br>
<input type="radio" name="suexec" value="1" checked="checked">gpĂ
<br>
<p>
<input type="submit" value="s">
</p>
<input type="hidden" name="mode" value="run">
</form>
</body>
</html>
HTML

	return $html;
}

sub getInitOKHtml{
	my $self=shift;

	my $html='';
$html=<<HTML;
<html>
<body>
<h1>MySketch</h1>
<p>MySketch̏܂I</p>
<a href="$ENV{SCRIPT_NAME}">Top</a>
</body>
</html>
HTML

	return $html;
}

1;
