package Msm::MySketch::File;

use strict;
use Time::Local;
use Msm::CGI;

sub new{
	my $self=shift;
	my $ms=shift;
	my $hash={};
	bless $hash,$self;
	$hash->{MS}=$ms;

	return $hash;
}

sub createDataDir{
	my $self=shift;
	my $file=shift;
	my $date=shift;

	$self->getIO->createDir($self->{MS}->getDataDir().$file);
}

sub updateDataDir{
	my $self=shift;
	my $dir=shift;
	my $date=shift;
	utime $date,$date,$self->{MS}->getDataDir().$dir;
}

#Lt@Cǂݍ
sub getSketchFiles{
	my $self=shift;
	my $dir=shift;	#fBNgw
	my $file=shift;	#t@Cw
	my $s_date=shift;	#Jnt
	my $e_date=shift; #It
	my $hash={};

	if($file){
		if($file!~/\.\./){
			$hash=$self->{MS}->getDirFile($self->{MS}->getDataDir().$dir,$file.'.txt',{});
		}
	}elsif($dir){
		if($dir!~/\.\./){
			$hash=$self->{MS}->getDirFiles($self->{MS}->getDataDir().$dir,{});
		}

	}else{

		#cacheǂݍ
		if($self->{MS}->{GetDataFileAll}){
			$hash=$self->{MS}->{GetDataFileAll};
		}else{
			my $dirs=$self->{MS}->getAllDirs($self->{MS}->getDataDir(),{});

			foreach my $v(keys %{$dirs}){
				$hash=$self->{MS}->getDirFiles($v,$hash);
				#print"$v=".$_."<br>" foreach(keys %{$hash});
			}
			#cacheZbg
			$self->{MS}->{GetDataFileAll}=$hash;
		}

	}

	#tōiB
	if(($s_date) && ($e_date) && $s_date ne '' && $e_date ne ''){
		my $datehash={};
		foreach my $file(keys %{$hash}){
			if($hash->{$file} >= $s_date && $hash->{$file} <= $e_date){
				$datehash->{$file}=$hash->{$file};
			}
		}
		$hash=$datehash;
	}

	return $hash;
}

sub getSketchData{
	my $self=shift;
	my $file=shift;
	my $dhash=shift;
	my $ddir=$self->{MS}->getDataDir();
	my $title;
	my $date;
	my $come;
	my $dir;
	my $file2;

	unless(-f $file){
		return {};
	}

	my @ret=$self->{MS}->getIO->readFileArray($file);

	
	unless($dhash->{date}){
		$date=(stat $file)[9];
	}
	unless($dhash->{dirfile}){

		if($file =~ /^$ddir(.*)\/(.*)\.txt$/){
			$dir=$1;
			$file2=$2;
		}
	}
	unless($dhash->{data}){
		$title=shift @ret;
		chomp $title;
		$come.=$_ foreach(@ret);
	}
	return {dir=>$dir,file=>$file2,title=>$title,comment=>$come,date=>$date};
}

sub getAllDirs{
	my $self=shift;
	my $dir=shift;
	my $dircheck=shift;
	if($self->{MS}->{GetDataDirAll}){
		return $self->{MS}->{GetDataDirAll};
	}
	$self->{MS}->{GetDataDirAll}=$self->{MS}->getAllDirsNoCache($dir,{});
	return $self->{MS}->{GetDataDirAll};
}

sub getAllDirsNoCache{
	my $self=shift;
	my $dir=shift;
	my $dircheck=shift;

	my $dirs=$self->{MS}->getDirs($dir,{});
	foreach(keys %{$dirs}){

		$dircheck->{$_}=$dirs->{$_};
		$self->{MS}->getAllDirsNoCache($_,$dircheck);
	}
	
	$self->{MS}->{GetDataDirAll}=$dircheck;
	return $dircheck;
}

sub getDirs{
	my $self=shift;
	my $dir=shift;
	my $dirs=shift;
	
	opendir DIR,$dir;
	while(my $entry=readdir DIR){
		if($entry eq '.' || $entry eq '..'){next;}
		if(-d "$dir/$entry"){
			my @stat=stat "$dir/$entry";
			$dirs->{"$dir/$entry"}=$stat[9];
			#print "ok=$dir/$entry\n";
		}
	}
	closedir(DIR);
	return $dirs;
}

#fBNgLǂݍ
sub getDirFiles{
	my $self=shift;
	my $dir=shift;
	my $files=shift;
	my $cache={};

	#cacheǂݍ݁B
	if($self->{MS}->{GetDataFile}->{$dir}){
		foreach(keys %{$self->{MS}->{GetDataFile}->{$dir}}){
			$files->{$_}=$self->{MS}->{GetDataFile}->{$dir}->{$_};
		}
		return $files;
	}

	opendir DIR,$dir;
	while(my $entry=readdir DIR){
		$files=$self->{MS}->getDirFile($dir,$entry,$files,$cache);
	}
	closedir(DIR);

	#cache
	$self->{MS}->{GetDataFile}->{$dir}=$cache;

	return $files;
}

sub getDirFilesData{
	my $self=shift;
	my $dir=shift;
	my $files={};

	#cacheǂݍ݁B
	if($self->{MS}->{GetDataFile}->{$dir}){

		foreach(keys %{$self->{MS}->{GetDataFile}->{$dir}}){
			$files->{$_}=$self->{MS}->{GetDataFile}->{$dir}->{$_};
		}
	}else{
		$files=$self->{MS}->getDirFiles($dir,$files);
	}
	my $hash={};
	foreach my $v(keys %{$files}){

		$hash->{$v}=$self->{MS}->getSketchData($v);
	}
	return $hash;
}

sub getDirCnt{
	my $self=shift;
	my $dir=shift;
	my $files=shift;

	#cacheǂݍ݁B
	if($self->{MS}->{GetDataFile}->{$dir}){
		return keys %{$self->{MS}->{GetDataFile}->{$dir}};
	}

	return keys %{$self->getDirFiles($dir,{})};
}

#Lǂݍ
sub getDirFile{
	my $self=shift;
	my $dir=shift;
	my $entry=shift;
	my $files=shift;
	my $cache=shift;

	if((-f "$dir/$entry")){
		my @stat=stat "$dir/$entry";
		$files->{"$dir/$entry"}=$stat[9];
		$cache->{"$dir/$entry"}=$stat[9];
	}

	return $files;
}

sub getDataDate{
	my $self=shift;
	my $fullname=shift;
	my $db=shift;
	my $ddir=$self->{MS}->getDataDir();
	return (stat $fullname)[9];
}

#LbV̕ύX
sub changeCache{
	my $self=shift;
	my $fullname=shift;

	my $time=(stat $fullname)[9];
	my $ddir=$self->{MS}->getDataDir();
	if($fullname =~ /\.txt$/){
		if($self->{MS}->{GetDataFileAll}){
			$self->{MS}->{GetDataFileAll}->{$fullname}=$time;
		}
		if($fullname=~/^($ddir\/.+)\/.+/){
			my $tmp=$1;
			if($self->{MS}->{GetDataFile}){
				$self->{MS}->{GetDataFile}->{$tmp}->{$fullname}=$time;
			}
			if($self->{MS}->{GetDataDirAll}){
				$self->{MS}->{GetDataDirAll}->{$tmp}=(stat $tmp)[9];
				while($tmp=~/^($ddir\/.+)\/.+/){
					$tmp=$1;
					$self->{MS}->{GetDataDirAll}->{$tmp}=(stat $tmp)[9];
				}
			}
		}
	}else{
		if($self->{MS}->{GetDataDirAll}){
			$self->{MS}->{GetDataDirAll}->{$fullname}=$time;
		}
	}
}

#L֘A
sub createSketch{
	my $self=shift;
	my $dir=shift;
	my $file=shift;
	my $title=shift;
	my $comment=shift;
	my $date=shift;

	$self->_createSketch($dir,$file,$title,$comment,$date,1);
}

sub createSketchNoRemake{
	my $self=shift;
	my $dir=shift;
	my $file=shift;
	my $title=shift;
	my $comment=shift;
	my $date=shift;

	$self->_createSketch($dir,$file,$title,$comment,$date,0);
}

sub _createSketch{
	my $self=shift;
	my $dir=shift;
	my $file=shift;
	my $title=shift;
	my $comment=shift;
	my $date=shift;
	my $remake=shift;

	my $dirtime_dir=undef;
	my $dirtime_name=undef;
	unless(-e $self->{MS}->getDataDir().$dir){
		if($dir=~/^(.+)\/.+$/){
			$dirtime_name=$1;
			$dirtime_dir=(stat $self->{MS}->getDataDir().$1)[9];
		}
	}

	$self->{MS}->getIO->createDir($self->{MS}->getDataDir().$dir.'/'.$file);

	utime $dirtime_dir,$dirtime_dir,($self->{MS}->getDataDir()."$dirtime_name") if ($dirtime_dir && $dirtime_name);

	my $utime='';
	my $motodate=undef;
	my $dirtime=undef;
	if(-e $self->{MS}->getDataDir()."$dir/$file.txt"){
		$motodate=(stat $self->{MS}->getDataDir()."$dir/$file.txt")[9];
		$utime=$motodate;
	}else{
		#dir̍XVԂQbg񂾁B
		$dirtime=(stat $self->{MS}->getDataDir()."$dir")[9];
	}
	if($date){
		my $dy=substr($date,0,4);
		my $dm=substr($date,4,2);
		my $dd=substr($date,6,2);
		my $dh=substr($date,8,2);
		my $dmin=substr($date,10,2);
		my $ds=substr($date,12,2);
		$utime=timelocal($ds,$dmin,$dh,$dd,$dm-1,$dy);
	}

	my $out='';
	$out.="$title\n";
	$out.="$comment";
	$self->{MS}->getIO->writeFile($self->{MS}->getDataDir()."$dir/$file.txt",$out);

	utime $utime,$utime,($self->{MS}->getDataDir()."$dir/$file.txt") if ($utime);
	utime $dirtime,$dirtime,($self->{MS}->getDataDir()."$dir") if ($dirtime);

	if($remake){
		$self->{MS}->{NewFile}->{dir}=$dir;
		$self->{MS}->{NewFile}->{file}=$file;
		$self->{MS}->{NewFile}->{title}=$title;
		$self->{MS}->{NewFile}->{comment}=$comment;
	}

	#$self->{MS}->clearCache();	LbVNAႤƏdȂ̂ŕύX
	my $fullname=$self->{MS}->getDataDir()."$dir/$file.txt";
	$self->{MS}->changeCache($fullname);

	if($remake){
		#t@CCtH
		$self->{MS}->createFileInfoFromCache();

		#t@CtύXꍇ͂̑Ô̂XVȂƂȂB
		if(($motodate) && ($date)){
			my $static=new Msm::StaticHtml($self->{MS}->getConfig(),$self->{MS}->getIO(),$self->{MS}->getAdConfig());
			my $ms=new Msm::MySketch(new Msm::CGI(),$self->{MS}->getConfig(),$self->{MS}->getIO(),$self->{MS}->getAdConfig(),$self->{MS}->getDB(),$self->{MS}->{JCode});
			my ($sec,$min,$hour,$day,$mon,$year,$wday,$yday,$isdst)=localtime($motodate);
			$year+=1900;
			$mon++;
			my $hdate=sprintf('%04d/%02d/%02d',$year,$mon,$day);
			$static->createMonth($hdate,$ms,'1');
			$static->createDay($hdate,$ms,'1');
		}

		#蒼
		new Msm::StaticHtml($self->{MS}->getConfig(),$self->{MS}->getIO(),$self->{MS}->getAdConfig())->createSketchAll("$dir/$file",$self->{MS}->{JCode});

		#RSSXV
		if($self->{MS}->getConfig->getConfigData('default','rssnocreate') eq '1'){
			new Msm::RSS()->createSketchRSS($self->{MS},$self->{MS}->getSketchFiles(),$self->{MS}->getConfigData('','rsscode'),'');
		}
	}
}

sub clearSketchAndDir{
	my $self=shift;
	my $file=shift;
	$self->_clearSketchAndDir($file,1);
}

sub clearSketchAndDirNoRemake{
	my $self=shift;
	my $file=shift;
	$self->_clearSketchAndDir($file,0);
}

sub _clearSketchAndDir{
	my $self=shift;
	my $file=shift;
	my $remake=shift;

	if(-e $self->{MS}->getDataDir().$file){

		$self->{MS}->deleteCache($self->{MS}->getDataDir().$file);
		if($remake){
			#t@CCtH
			$self->{MS}->createFileInfoFromCache();
		}

		if(-d $self->{MS}->getDataDir().$file){
			my $r=rmdir($self->{MS}->getDataDir().$file);
			#print "$r".$self->{MS}->getDataDir().$file;
			#蒼
			if($remake){
				new Msm::StaticHtml($self->{MS}->getConfig(),$self->{MS}->getIO(),$self->{MS}->getAdConfig())->createIndex();
			}
		}else{

			unlink($self->{MS}->getDataDir().$file);
			#蒼
			if($remake){
				new Msm::StaticHtml($self->{MS}->getConfig(),$self->{MS}->getIO(),$self->{MS}->getAdConfig())->createSketchAll("$file",$self->{MS}->{JCode});
			}
		}
		#RSSXV
		if($remake && $self->{MS}->getConfig->getConfigData('default','rssnocreate') eq '1'){
			new Msm::RSS()->createSketchRSS($self->{MS},$self->{MS}->getSketchFiles(),$self->{MS}->getConfigData('','rsscode'),'');
		}
	}
}

sub createFileInfo{
	my $self=shift;
	my $file={};

	if($self->{MS}->getConfigData('','usefileinfo') ne '1'){
		return;
	}

	my $dirs=$self->{MS}->getAllDirsNoCache($self->{MS}->getDataDir(),{});
	my $filehash=$self->{MS}->getSketchFiles();

	foreach my $key(keys %{$dirs}){
		opendir DIR2,$key;
		while(my $entry2=readdir DIR2){
			if((-f "$key/$entry2")){
				if(($filehash->{"$key/$entry2"}) && $self->{MS}->getConfigData('','timestamp') eq '1'){
					$file->{"$key/$entry2"}=$filehash->{"$key/$entry2"};
					utime $file->{"$key/$entry2"},$file->{"$key/$entry2"},("$key/$entry2");
				}else{
					my @stat=stat "$key/$entry2";
					$file->{"$key/$entry2"}=$stat[9];
				}
			}
		}
		closedir(DIR2);
	}

	my $out='';
	foreach my $v(sort keys %{$file}){
		$out.=$v.'<>'.$file->{$v}."\n";
	}
	if($self->{MS}->getConfig->{FILENAME} eq 'Config'){
		$self->{MS}->getIO->writeFile('./ini/fileinfo.txt',$out);
	}else{
		$self->{MS}->getIO->writeFile($self->{MS}->getAdConfigData('userdatadir').'/'.$self->{MS}->getCGI->param('blogid').'/ini/fileinfo.txt',$out);
	}
}

sub createFileInfoFromCache{
	my $self=shift;
	my $file=$self->{MS}->{GetDataFileAll};

	if($self->{MS}->getConfigData('','usefileinfo') ne '1'){
		return;
	}

	my $out='';
	foreach my $v(sort keys %{$file}){
		$out.=$v.'<>'.$file->{$v}."\n";
	}
	if($self->{MS}->getConfig->{FILENAME} eq 'Config'){
		$self->{MS}->getIO->writeFile('./ini/fileinfo.txt',$out);
	}else{
		$self->{MS}->getIO->writeFile($self->{MS}->getAdConfigData('userdatadir').'/'.$self->{MS}->getCGI->param('blogid').'/ini/fileinfo.txt',$out);
	}
}

sub readFileInfo{
	my $self=shift;
	my @info=();
	if($self->{MS}->getConfig->{FILENAME} eq 'Config'){
		@info=$self->{MS}->getIO->readFileArray('./ini/fileinfo.txt');
	}else{
		@info=$self->{MS}->getIO->readFileArray($self->{MS}->getAdConfigData('userdatadir').'/'.$self->{MS}->getCGI->param('blogid').'/ini/fileinfo.txt');
	}
	my $hash={};

	my $dir=$self->{MS}->getDataDir();
	foreach my $v(@info){
		chomp $v;
		my($file,$time)=split(/<>/,$v);
		if($file=~/^$dir(\/.+)\//o){
			my $tmp=$1;
			$hash->{$file}=$time;
			$self->{MS}->{GetDataFile}->{$dir.$tmp}->{$file}=$time;
			unless($self->{MS}->{GetDataDirAll}->{$dir.$tmp}){
				if(-e $dir.$tmp){
					$self->{MS}->{GetDataDirAll}->{$dir.$tmp}=(stat $dir.$tmp)[9];
					while($tmp=~/^(\/.+)\/.+/o){
						$tmp=$1;
						unless($self->{MS}->{GetDataDirAll}->{$dir.$1}){
							$self->{MS}->{GetDataDirAll}->{$dir.$1}=(stat $dir.$1)[9];
						}
					}
				}
			}
		}
	}
	$self->{MS}->{GetDataFileAll}=$hash;

	return $hash;
}

sub createPlugDir{
	my $self=shift;
	my $plug=shift;
	my $dir=shift;
	$dir='' if !defined($dir);
	$plug='' if !defined($plug);
	$self->{MS}->getIO->createDir($self->{MS}->getPlugDataDir().'/'.$plug.$dir);
}

sub writePlugData{
	my $self=shift;
	my $plug=shift;
	my $dir=shift;
	my $file=shift;
	my $data=shift;

	$self->createPlugDir($plug,$dir.'/'.$file);
	$self->{MS}->getIO->writeFile($self->{MS}->getPlugDataDir().'/'.$plug.$dir.'/'.$file,$data);
}

sub existsPlugData{
	my $self=shift;
	my $plug=shift;
	my $dir=shift;
	my $file=shift;

	if(-e $self->{MS}->getPlugDataDir().'/'.$plug.$dir.'/'.$file){
		return 1;
	}else{
		return 0;
	}
}

sub readPlugData{
	my $self=shift;
	my $plug=shift;
	my $dir=shift;
	my $file=shift;

	return $self->{MS}->getIO->readFileArray($self->{MS}->getPlugDataDir().'/'.$plug.$dir.'/'.$file);
}

sub deletePlugData{
	my $self=shift;
	my $plug=shift;
	my $dir=shift;
	my $file=shift;

	unlink($self->{MS}->getPlugDataDir().'/'.$plug.$dir.'/'.$file);
}

sub getPlugDirs{
	my $self=shift;
	my $dir=shift;
	my $dircheck=shift;

	my $d=$self->{MS}->getPlugDataDir();
	$dir=~s/^$d//;
	my $dirs=$self->{MS}->getDirs($d.$dir,{});
	foreach(keys %{$dirs}){

		$dircheck->{$_}=$dirs->{$_};
		$self->{MS}->getPlugDirs($_,$dircheck);
	}

	return $dircheck;
}

sub getPlugDirFiles{
	my $self=shift;
	my $dir=shift;
	my $files=shift;

	opendir DIR,$dir;
	while(my $entry=readdir DIR){
		if(-f $dir.'/'.$entry){
			$files->{$dir.'/'.$entry}=1;
		}
	}
	closedir(DIR);

	return $files;
}

1;
