package Msm::StaticHtml;

use strict;
use Msm::MySketch;
use Msm::CGI;

sub new{
	my $self=shift;
	my $config=shift;
	my $io=shift;
	my $adconfig=shift;
	my $data=shift;
	my $hash={};
	bless $hash,$self;
	$hash->{CGI}=new Msm::CGI();
	$hash->{DATA}=$data;
	$hash->{Config}=$config;
	$hash->{IO}=$io;
	$hash->{AdConfig}=$adconfig;
	$hash->{CATE}={};
	return $hash;
}

sub getCGI{
	my $self=shift;
	return $self->{CGI};
}

sub getConfigData{
	my $this=shift;
	my $name=shift;
	return $this->{Config}->getConfigData('',$name);
}

#
#	Ss
#
sub createSketchAll{
	my $this=shift;
	my $sketch=shift;
	my $jcode=shift;

	if($this->getConfigData('staticmode') != 1){return;}

	my $ms=new Msm::MySketch($this->{CGI},$this->{Config},$this->{IO},$this->{AdConfig},$this->{Config}->getDB(),$jcode);

	my $data=$ms->getSketchData($ms->getDataDir().$sketch.'.txt',{});
	my $time=time;
	if(defined($data->{date})){
		$time=$data->{date};
	}
	my ($sec,$min,$hour,$day,$mon,$year,$wday,$yday,$isdst)=localtime($time);
	$year+=1900;
	$mon++;
	my $date=sprintf('%04d/%02d/%02d',$year,$mon,$day);

	$this->createIndex($ms,'1');
	$this->createSketch($sketch,$ms,'1');
	$this->createCategory($sketch,$ms,'1');
	$this->createDay($date,$ms,'1');
	$this->createMonth($date,$ms,'1');
}

#
#	CfbNXHTML쐬B
#
sub createIndex{
	my $this=shift;
	my $ms=shift;
	my $cell=shift;

	if($this->getConfigData('staticmode') != 1 || $this->getConfigData('staticmode_index') != 1){return;}

	my $self=undef;
	unless($ms){
		$self=new Msm::MySketch($this->{CGI},$this->{Config},$this->{IO},$this->{AdConfig},$this->{Config}->getDB(),$ms->{JCode});
	}else{
		$self=$ms;
		$self->dataClear();
		$self->clearErr();
	}

	my $pathinfo=$ENV{PATH_INFO};
	$ENV{PATH_INFO}='' if defined($pathinfo);


	$self->getIO->createDir($this->getConfigData('staticindexdir').'/index.html');

	my $bid=$self->getCGI->param('blogid');

	#NGNA
	$self->getCGI->delete_all();

	#NGZbg
	$self->getCGI->param(-name=>'blogid',-value=>$bid);
	$self->getCGI->param(-name=>'t',-value=>'index');

	$this->_create($self,'index',$cell);
	$ENV{PATH_INFO}=$pathinfo if defined($pathinfo);
}

#
#	XPb`HTML쐬
#
sub createSketch{
	my $this=shift;
	my $sketch=shift;
	my $ms=shift;
	my $cell=shift;

	if($this->getConfigData('staticmode') != 1 || $this->getConfigData('staticmode_sketch') != 1){return;}

	my $self=undef;
	unless($ms){
		$self=new Msm::MySketch($this->{CGI},$this->{DATA},$this->{Config},$this->{IO},$this->{AdConfig},$this->{Config}->getDB(),$ms->{JCode});
	}else{
		$self=$ms;
		$self->dataClear();
		$self->clearErr();
	}

	my $pathinfo=$ENV{PATH_INFO};
	$ENV{PATH_INFO}='' if defined($pathinfo);

	$self->getIO->createDir($this->getConfigData('staticindexdir').'category'.$sketch);

	my $bid=$self->getCGI->param('blogid');

	#NGNA
	$self->getCGI->delete_all();

	#NGZbg
	$self->getCGI->param(-name=>'blogid',-value=>$bid);
	$self->getCGI->param(-name=>'t',-value=>'sketch');
	$self->getCGI->param(-name=>'ShowDiary_file',-value=>$sketch);

	$this->_create($self,'category'.$sketch,$cell);
	$ENV{PATH_INFO}=$pathinfo if defined($pathinfo);
}

#
#	JeSHTML쐬
#
sub createCategory{
	my $this=shift;
	my $category=shift;
	my $ms=shift;
	my $cell=shift;

	if($this->getConfigData('staticmode') != 1 || $this->getConfigData('staticmode_category') != 1){return;}

	#nocategory͍\zȂB
	if($category =~ /^\/nocategory/){
		return;
	}

	my $self=undef;
	while($category =~ /^\/.+\/.+$/){
		$category=~s/(.*)\/.*/$1/;

		if($self->{CATE}->{$category}){next;}
		$self->{CATE}->{$category}=1;

		unless($ms){
			$self=new Msm::MySketch($this->{CGI},$this->{DATA},$this->{Config},$this->{IO},$this->{AdConfig},$this->{Config}->getDB(),$ms->{JCode});
		}else{
			$self=$ms;
			$self->dataClear();
			$self->clearErr();
		}

		my $pathinfo=$ENV{PATH_INFO};
		$ENV{PATH_INFO}='' if defined($pathinfo);

		$self->getIO->createDir($this->getConfigData('staticindexdir').'category'.$category);

		my $bid=$self->getCGI->param('blogid');

		#NGNA
		$self->getCGI->delete_all();

		#NGZbg
		$self->getCGI->param(-name=>'blogid',-value=>$bid);
		$self->getCGI->param(-name=>'t',-value=>'category');
		$self->getCGI->param(-name=>'ShowDiary_dir',-value=>$category);

		$this->_create($self,'category'.$category,$cell);
		$ENV{PATH_INFO}=$pathinfo if defined($pathinfo);
	}
}


#
#	ɂHTML쐬
#
sub createDay{
	my $this=shift;
	my $date=shift;
	my $ms=shift;
	my $cell=shift;

	if($this->getConfigData('staticmode') != 1 || $this->getConfigData('staticmode_day') != 1){return;}

	my $self=undef;
	unless($ms){
		$self=new Msm::MySketch($this->{CGI},$this->{DATA},$this->{Config},$this->{IO},$this->{AdConfig},$this->{Config}->getDB(),$ms->{JCode});
	}else{
		$self=$ms;
		$self->dataClear();
		$self->clearErr();
	}

	my $pathinfo=$ENV{PATH_INFO};
	$ENV{PATH_INFO}='' if defined($pathinfo);

	$self->getIO->createDir($this->getConfigData('staticindexdir').'date/'.$date);

	my $bid=$self->getCGI->param('blogid');

	#NGNA
	$self->getCGI->delete_all();

	#NGZbg
	$self->getCGI->param(-name=>'blogid',-value=>$bid);
	$self->getCGI->param(-name=>'t',-value=>'day');
	$self->getCGI->param(-name=>'ShowDiary_date',-value=>$date);

	$this->_create($self,'date/'.$date,$cell);
	$ENV{PATH_INFO}=$pathinfo if defined($pathinfo);
}

#
#	HTML쐬
#
sub createMonth{
	my $this=shift;
	my $date=shift;
	my $ms=shift;
	my $cell=shift;

	if($this->getConfigData('staticmode') != 1 || $this->getConfigData('staticmode_month') != 1){return;}

	my $self=undef;
	unless($ms){
		$self=new Msm::MySketch($this->{CGI},$this->{DATA},$this->{Config},$this->{IO},$this->{AdConfig},$this->{Config}->getDB(),$ms->{JCode});
	}else{
		$self=$ms;
		$self->dataClear();
		$self->clearErr();
	}

	my $pathinfo=$ENV{PATH_INFO};
	$ENV{PATH_INFO}='' if defined($pathinfo);

	$date=~s/(.*)\/(.*)/$1/;

	$self->getIO->createDir($this->getConfigData('staticindexdir').'date/'.$date);

	my $bid=$self->getCGI->param('blogid');

	#NGNA
	$self->getCGI->delete_all();

	#NGZbg
	$self->getCGI->param(-name=>'blogid',-value=>$bid);
	$self->getCGI->param(-name=>'t',-value=>'month');
	$self->getCGI->param(-name=>'ShowDiary_date',-value=>$date.'/');

	$this->_create($self,'date/'.$date,$cell);
	$ENV{PATH_INFO}=$pathinfo if defined($pathinfo);
}

sub _create{
	my $this=shift;
	my $self=shift;
	my $file=shift;
	my $cell=shift;

	#print "create $file<br>\n";

	$self->{DATA}->{'MySketch'}->{'generator'}='MySketch GE '.$self->{Version};

	my $ca=$self->get_ca();
	$self->set_ca('PC');

	$self->plugin_init();

	$self->plugin_execute();

	my $tmp=$self->load_template($self->getCGI->param('t'),'PC');

	$tmp=$self->changer($tmp);

	$tmp=$self->plugin_change($tmp);
	$tmp=$self->foot($tmp);
	$self->getIO->writeFile($this->getConfigData('staticindexdir').$file.'.html',$tmp);

	$tmp=$self->load_template($self->getCGI->param('t'),'i');
	if(defined($tmp) && defined($cell) && $cell eq '1'){
		$self->set_ca('i');
		$self->dataClear();
		$self->clearErr();
		$self->plugin_init();
		$self->plugin_execute();
		$tmp=$self->changer($tmp);
		$tmp=$self->plugin_change($tmp);
		$tmp=$self->foot($tmp);
		$self->getIO->writeFile($this->getConfigData('staticindexdir').$file.'.i.html',$tmp);
	}

	$self->set_ca($ca);
}

1;
